src/DelegateWise/Controllers/InscriptionController.cs
using DelegateWise.Data.Exceptions;
using DelegateWise.ViewModels;
using Microsoft.AspNetCore.Mvc;

namespace delegatewise.Controllers
{
    public class InscriptionController : MyController
    {
        public IActionResult Index(string hash)
        {
            try
            {
                Dal.CheckInvitation(hash);
                return View(new CreateUserViewModel(hash));
            }
            catch (ExpiredInvitationException)
            {
                return View("InvitationError");
            }
        }

        [HttpPost]
        public IActionResult Index(CreateUserViewModel model)
        {
            if (!ModelState.IsValid)
                return View();

            try
            {
                Dal.CheckInvitation(model.Invitation);
                Dal.CreateUser(model.User);
                Dal.UseInvitation(model.Invitation);
                return Redirect("/");
            }
            catch (EmailAlreadyUsedException e)
            {
                ModelState.AddModelError("User.Email", e.Message);
                return View();
            }
            catch (ExpiredInvitationException)
            {
                return View("InvitationError");
            }
        }
    }
}

src/DelegateWise/Views/Inscription/Index.cshtml
@model CreateUserViewModel
@{
    ViewData["Title"] = "Register";
    Layout = "_LayoutPrivate";
}

<img src="~/img/logo.png" alt="Logo">

@using (Html.BeginForm("Index", "Inscription"))
{
    @Html.HiddenFor(model => model.Invitation)
    <div>
        @Html.LabelFor(model => model.User.FullName)
        @Html.TextBoxFor(model => model.User.FullName)
        @Html.ValidationMessageFor(model => model.User.FullName)
    </div>
    <div>
        @Html.LabelFor(model => model.User.Email)
        @Html.TextBoxFor(model => model.User.Email)
        @Html.ValidationMessageFor(model => model.User.Email)
    </div>
    <div>
        @Html.LabelFor(model => model.User.Password)
        @Html.PasswordFor(model => model.User.Password)
        @Html.ValidationMessageFor(model => model.User.Password)
    </div>
    <input type="submit" value="Apply"/>
}

src/DelegateWise/Views/Inscription/InvitationError.cshtml
@{
    ViewData["Title"] = "Error";
    Layout = "_LayoutPrivate";
}

<img src="~/img/logo.png" alt="Logo">
<h1 class="text-danger">Your invitation is not available anymore.</h1>